/* Copyright (c) 2004 Limor Fried <ladyada@media.mit.edu>, MIT Media Lab

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/
struct uip_dns {
  uip_udpip_hdr udphdr;
  uint16_t transaction_id;
  uint16_t flags;
  uint16_t questions;
  uint16_t answer_RRs;
  uint16_t auth_RRs;
  uint16_t add_RRs;
  char data[128];
};

uint8_t *inc_past_name(uint8_t *buff);

#define DNSBUF ((struct uip_dns *)&uip_buf[UIP_LLH_LEN])
#define DNS_CLIENT_PORT 2000     // arbitrary
#define DNS_SERVER_PORT 53

void dns_init(uint16_t *ns);
uint8_t lookup(char *name);

extern uint16_t dns_nameserver[2];
extern uint16_t dns_resolved[2];

#define DNS_OK 0
#define DNS_TIMEOUT 1
#define DNS_NOSUCHNAME 2
