/* Copyright (c) 2004 Limor Fried <ladyada@media.mit.edu>, MIT Media Lab

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/

#include "tcp.h"

void ioinit(void);
void halt(void);

/* Macros. */
#define ETHBUF ((struct uip_eth_hdr *)&uip_buf[0])
#define IPBUF ((uip_ip_hdr *)&uip_buf[UIP_LLH_LEN])
#define TCPBUF ((uip_tcpip_hdr *)&uip_buf[UIP_LLH_LEN])
#define ICMPBUF ((uip_icmpip_hdr *)&uip_buf[UIP_LLH_LEN])
#define UDPBUF ((uip_udpip_hdr *)&uip_buf[UIP_LLH_LEN])

int uart_putchar(char c);
int uart_getchar(void);
unsigned char getTimer0(void);
unsigned char getTimerCounter(void);
void printIP(uint16_t *addr);
void putstring(char *str);
uint16_t rnd(void);

void http_established(tcp_conn *conn, uint8_t *data, uint16_t len);

extern uint8_t DEBUG;

#define ICMP_ECHO_REPLY 0
#define ICMP_ECHO       8     

#define UDP_LET_LARGE_DNS_THROUGH 1
