/* Copyright (c) 2004 Limor Fried <ladyada@media.mit.edu>, MIT Media Lab

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/

#include <inttypes.h>
#include "uip_arp.h"
#include "uip_arch.h"
#include "nic.h"
#include "udp.h"
#include <stdio.h>

/*
void udp_print_hdr(void) {
  // prints out whats in UDPBUF
  printf("IP  vhl: %x tos: %x len: %d id: %d flag: %x frag: %d ttl: %d proto: %d sum: %d src: %x%x dst: %x%xn\r", UDPBUF->vhl,
	 UDPBUF->tos, UDPBUF->len[0] | (UDPBUF->len[1] << 8),
	 UDPBUF->ipid[0] | (UDPBUF->ipid[1] << 8),
	 UDPBUF->ipoffset[0] >> 4,
	 (UDPBUF->ipoffset[0] & 0xf) | (UDPBUF->ipid[1] << 4),
	 UDPBUF->ttl, UDPBUF->proto, UDPBUF->ipchksum,
	 UDPBUF->srcipaddr[0],   UDPBUF->srcipaddr[1],
	 UDPBUF->srcipaddr[0],   UDPBUF->srcipaddr[1]);
  printf("UDP len: %d, src: %d, dst: %d, sum: %d\n\r", 
	 UDPBUF->udplen, UDPBUF->srcport, UDPBUF->destport, 
	 UDPBUF->udpchksum);
}

*/


// ick messy, fix me up?
uint16_t uip_udpchksum(void) {
  uint32_t sum = 0;
  uint16_t len = UDPBUF->udplen >> 8;
  len |= (UDPBUF->udplen & 0xff) << 8;

  // get the checksum of the pseudo header
  sum = 0;
  sum += UDPBUF->srcipaddr[0];
  sum += UDPBUF->srcipaddr[1];
  sum += UDPBUF->destipaddr[0];
  sum += UDPBUF->destipaddr[1];
  sum += UDPBUF->proto;
  sum += len;
  while (sum >> 16)
    sum = (sum & 0xFFFF) + (sum >> 16);
  sum = sum << 8 | sum >> 8;

  sum += uip_chksum((u16_t *)&uip_buf[UIP_LLH_LEN + IP_HEADER_LEN], len);

  while (sum >> 16)
    sum = (sum & 0xFFFF) + (sum >> 16);
  len = sum;
  return len;
}

void udp_send_packet(uint16_t *srcIP, uint16_t *destIP,
		     uint16_t srcport, uint16_t destport,
		     uint16_t len) {

  // set up the udp header
  len += UDP_HEADER_LEN;
  UDPBUF->udplen = HTONS(len);
  UDPBUF->srcport = HTONS(srcport);
  UDPBUF->destport = HTONS(destport);
  UDPBUF->udpchksum = 0;

  len += IP_HEADER_LEN;
  // set up the ip header
  UDPBUF->vhl = 0x45;
  UDPBUF->tos = 0;
  UDPBUF->len[0] = (len >> 8) & 0xff;
  UDPBUF->len[1] = len & 0xff;
  UDPBUF->ipid[0] = 0;
  UDPBUF->ipid[1] = 0;
  UDPBUF->ipoffset[0] = 0;
  UDPBUF->ipoffset[1] = 0;
  UDPBUF->ttl = 64;
  UDPBUF->proto = UIP_PROTO_UDP;
  UDPBUF->srcipaddr[0] = srcIP[0];
  UDPBUF->srcipaddr[1] = srcIP[1];
  UDPBUF->destipaddr[0] = destIP[0];
  UDPBUF->destipaddr[1] =destIP[1];
  UDPBUF->ipchksum = 0;
  UDPBUF->ipchksum = ~(uip_ipchksum());
  UDPBUF->udpchksum = 0;
  /*
  UDPBUF->udpchksum = ~(uip_udpchksum()) + 0x100;
  if(UDPBUF->udpchksum == 0)
    UDPBUF->udpchksum = 0xffff;
  */
  uip_len = len;
  uip_arp_out();       // fill in the right arp addr

  //udp_print_hdr();

  NICBeginPacketSend(uip_len);
  
  NICSendPacketData(uip_buf, uip_len);
  NICEndPacketSend();
}
